# [80. Remove Duplicates from Sorted Array II](https://leetcode.com/problems/remove-duplicates-from-sorted-array-ii/)

## 题目

Given a sorted array nums, remove the duplicates in-place such that duplicates appeared at most twice and return the new length.

Do not allocate extra space for another array, you must do this by modifying the input array in-place with O(1) extra memory.

**Example 1**:

```

Given nums = [1,1,1,2,2,3],

Your function should return length = 5, with the first five elements of nums being 1, 1, 2, 2 and 3 respectively.

It doesn't matter what you leave beyond the returned length.

```

**Example 2**:

```

Given nums = [0,0,1,1,1,1,2,3,3],

Your function should return length = 7, with the first seven elements of nums being modified to 0, 0, 1, 1, 2, 3 and 3 respectively.

It doesn't matter what values are set beyond the returned length.

```

**Clarification**:

Confused why the returned value is an integer but your answer is an array?

Note that the input array is passed in by reference, which means modification to the input array will be known to the caller as well.

Internally you can think of this:

```

// nums is passed in by reference. (i.e., without making a copy)
int len = removeElement(nums, val);

// any modification to nums in your function would be known by the caller.
// using the length returned by your function, it prints the first len elements.
for (int i = 0; i < len; i++) {
    print(nums[i]);
}

```

## 题目大意

给定一个有序数组 nums，对数组中的元素进行去重，使得原数组中的每个元素最多暴露 2 个。最后返回去重以后数组的长度值。

## 解题思路

这道题和第 26 题很像。是第 26 题的加强版。这道题和第 283 题，第 27 题基本一致，283 题是删除 0，27 题是删除指定元素，这一题是删除重复元素，实质是一样的。

这里数组的删除并不是真的删除，只是将删除的元素移动到数组后面的空间内，然后返回数组实际剩余的元素个数，OJ 最终判断题目的时候会读取数组剩余个数的元素进行输出。

## 代码

```go

package leetcode

func removeDuplicates80(nums []int) int {
	if len(nums) == 0 {
		return 0
	}
	last, finder := 0, 0
	for last < len(nums)-1 {
		startFinder := -1
		for nums[finder] == nums[last] {
			if startFinder == -1 || startFinder > finder {
				startFinder = finder
			}
			if finder == len(nums)-1 {
				break
			}
			finder++
		}
		if finder-startFinder >= 2 && nums[finder-1] == nums[last] && nums[finder] != nums[last] {
			nums[last+1] = nums[finder-1]
			nums[last+2] = nums[finder]
			last += 2
		} else {
			nums[last+1] = nums[finder]
			last++
		}
		if finder == len(nums)-1 {
			if nums[finder] != nums[last-1] {
				nums[last] = nums[finder]
			}
			return last + 1
		}
	}
	return last + 1
}


```