---
title: 数据结构知识
type: docs
---

# 数据结构知识

以下是笔者整理的数据结构相关的知识。希望能把常见的数据结构都枚举穷尽。如有遗漏，欢迎大家赐教，提 PR。相关题目还在慢慢整理中，讲解的文章还在创作中。

> 刷题只是提升算法能力的手段，最终目的应该是提升自我的思维能力，知识需要凝结成块，那么就把这些总结在第一章这两节中，让它得到升华吧~希望读者在刷完题之后再回过头来看这个表格，能很清晰的梳理自己的知识体系，查缺补漏，尽早完善。

| 数据结构 | 变种 | 相关题目 | 讲解文章 | 
|:-------:|:-------|:------|:------|
|顺序线性表：向量 <br>Vector||||
|单链表<br>Singly Linked List|1. 双向链表 Double Linked Lists<br>2. 静态链表 Static List<br>3. 对称矩阵 Symmetric Matrix<br>4. 稀疏矩阵 Sparse Matrix|||
|哈希表<br>Hash Table|1. 散列函数 Hash Function<br>2. 解决碰撞/填充因子<br>|||
|栈和队列<br>Stack & Queue|1. 广义栈<br>2. 双端队列 Deque<br>|||
|队列<br>Queue|1. 链表实现<br>2. 循环数组实现<br>3. 双端队列 Deque|||
|字符串<br>String|1. KMP 算法<br>2. 有限状态自动机<br>3. 模式匹配有限状态自动机<br>4. BM 模式匹配算法<br>5. BM-KMP 算法<br>6. BF 算法|||
|树<br>Tree|1. 二叉树 Binary Tree<br>2. 并查集 Union-Find<br>3. Huffman 树|||
|数组实现的堆<br>Heap|1. 极大堆和极小堆<br>2. 极大极小堆<br>3. 双端堆 Deap<br>4. d 叉堆|||
|树实现的堆<br>Heap|1. 左堆<br>2. 扁堆<br>3. 二项式堆<br>4. 斐波那契堆 Fibonacco Heap<br>5. 配对堆 Pairing Heap|||
|查找<br>Find|1. 哈希表 Hash<br>2. 跳跃表 Skip List<br>3. 排序二叉树 Binary Sort Tree<br>4. AVL 树<br>5. B 树 / B+ 树 / B* 树<br>6. AA 树<br>7. 红黑树 Red Black Tree<br>8. 排序二叉堆 Binary Heap<br>9. Splay 树<br>10. 双链树 Double Chained Tree<br>11. Trie 树<br>12. R 树|||
|--------------------------------------------|--------------------------------------------------------------------------------------------|---------------------------|-----------------------------------|